package com.xxl.job.admin.core.thread;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.xxl.job.core.biz.model.RegistryParam;
import com.xxl.job.core.biz.model.ReturnT;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.RejectedExecutionHandler;
import java.util.concurrent.ThreadFactory;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.StringUtils;

public class JobRegistryHelper {
  private static Logger logger = LoggerFactory.getLogger(com.xxl.job.admin.core.thread.JobRegistryHelper.class);
  
  private static com.xxl.job.admin.core.thread.JobRegistryHelper instance = new com.xxl.job.admin.core.thread.JobRegistryHelper();
  
  public static com.xxl.job.admin.core.thread.JobRegistryHelper getInstance() {
    return instance;
  }
  
  private ThreadPoolExecutor registryOrRemoveThreadPool = null;
  
  private Thread registryMonitorThread;
  
  private volatile boolean toStop = false;
  
  public void start() {
    this.registryOrRemoveThreadPool = new ThreadPoolExecutor(2, 10, 30L, TimeUnit.SECONDS, new LinkedBlockingQueue<>(2000), (ThreadFactory)new Object(this), (RejectedExecutionHandler)new Object(this));
    this.registryMonitorThread = new Thread((Runnable)new Object(this));
    this.registryMonitorThread.setDaemon(true);
    this.registryMonitorThread.setName("xxl-job, admin JobRegistryMonitorHelper-registryMonitorThread");
    this.registryMonitorThread.start();
  }
  
  public void toStop() {
    this.toStop = true;
    this.registryOrRemoveThreadPool.shutdownNow();
    this.registryMonitorThread.interrupt();
    try {
      this.registryMonitorThread.join();
    } catch (Throwable e) {
      logger.error(e.getMessage(), e);
    } 
  }
  
  public ReturnT<String> registry(RegistryParam registryParam) {
    if (!StringUtils.hasText(registryParam.getRegistryGroup()) || 
      !StringUtils.hasText(registryParam.getRegistryKey()) || 
      !StringUtils.hasText(registryParam.getRegistryValue()))
      return new ReturnT(500, "Illegal Argument."); 
    this.registryOrRemoveThreadPool.execute((Runnable)new Object(this, registryParam));
    return ReturnT.SUCCESS;
  }
  
  public ReturnT<String> registryRemove(RegistryParam registryParam) {
    if (!StringUtils.hasText(registryParam.getRegistryGroup()) || 
      !StringUtils.hasText(registryParam.getRegistryKey()) || 
      !StringUtils.hasText(registryParam.getRegistryValue()))
      return new ReturnT(500, "Illegal Argument."); 
    this.registryOrRemoveThreadPool.execute((Runnable)new Object(this, registryParam));
    return ReturnT.SUCCESS;
  }
  
  private void freshGroupRegistryInfo(RegistryParam registryParam) {}
}
